import java.util.Scanner;

public class Jolie {
	static int ruaCliente;
	static int numeroCliente;
	static Endereco endCliente;

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in); // cria instancia do scanner
		while (sc.hasNext()){
			ruaCliente = sc.nextInt(); // le o numero da rua do cliente
			// le o numero do predio do cliente
			
			numeroCliente = sc.nextInt();
			
			//cria um objeto endereco a partir da rua e do numero
			endCliente = new Endereco(ruaCliente, numeroCliente);
			int conceitoDesejado = sc.nextInt();
			int n = sc.nextInt(); // numero de saloes na regiao 
			Salao[] opcoes = new Salao[n];
			
			// le os dados (rua, numero e conceito) dos n saloes presentes na regiao
			for (int i = 0; i < opcoes.length; i++) {
				int rua = sc.nextInt();
				int numero = sc.nextInt();
				Endereco endSalao = new Endereco(rua, numero);
				int conceito = sc.nextInt();
				opcoes[i] = new Salao(endSalao, conceito);
			}
			/*
			verifica quantos dos saloes presentes na regiao atendem ao conceito minimo
			pedido pelo cliente e os salva no vetor resultado
			*/
			int opValidas = 0;
			for (Salao s : opcoes)
				if (s.conceito >= conceitoDesejado) opValidas++;	
			
			Salao[] resultado = new Salao[opValidas];
			double[] dist = new double[opValidas];
			
			int cont = 0;
			for (Salao s : opcoes)
				if(s.conceito >= conceitoDesejado) resultado[cont++] = s; 
			
			// calcula as distancias dos saloes da localizacao do usuario
			for(int i=0; i<opValidas; i++)
				dist[i] = distancia(endCliente, resultado[i].endereco);
			
			// ordena os saloes 
			opcoes = ordena(resultado, dist);
			
			// exibe os saloes
			for (Salao s : resultado)
				System.out.println(s.toString());

		}
		sc.close();
	}

	static double distancia(Endereco a, Endereco b) {
		int xa, xb, ya, yb;
		if (a.rua % 2 == 0) { 	// se o numero da rua for par
			xa = a.numero; 		// x corresponde ao numero do predio 
			ya = a.rua * 300;	// e y ao numero da rua x 300
		}else{					// se o numero da rua for impar
			xa = a.rua * 300;	// x corresponde ao numero da rua x 300
			ya = a.numero;		// e y corresponde ao numero do predio 
		}
		if (b.rua % 2 == 0) {
			xb = b.numero;
			yb = b.rua * 300;
		} else {
			xb = b.rua * 300;
			yb = b.numero;
		}
		return Math.sqrt((xa-xb)*(xa-xb) + (ya-yb)*(ya-yb));
	}
	/*
	 Ordenacao (utilizando o metodo de ordenacao por selecao) dos saloes que atendem
	 ao criterio de conceito. 
	*/
	static Salao[] ordena(Salao[] saloes, double[] dist) {
		int i, j;
		int min;
		for (i = 0; i < saloes.length - 1; i++) {
			min = i;
			for(j = i + 1; j < saloes.length; j++){
				if (dist[j] < dist[min])
					min = j;
				else if ((dist[j] == dist[min]) && (saloes[j].conceito>saloes[min].conceito))
					min = j; // caso as distancias sejam iguais o conceito eh utilizado para desempate
			}
			if (min != i){
				Salao aux = saloes[i];
				saloes[i] = saloes[min];
				saloes[min] = aux;
			}
		}
		return saloes;
	}

}

// definicao do objeto endereco utilizado para representar 
// a localizacao do cliente e dos saloes
class Endereco {
	int rua;
	int numero;

	public Endereco(int rua, int numero) {
		this.rua = rua;
		this.numero = numero;
	}

	public String toString() {
		return rua + " " + numero;
	}
}

// definicao do objeto salao 
class Salao {
	Endereco endereco;
	int conceito;

	public Salao(Endereco e, int conceito) {
		this.endereco = e;
		this.conceito = conceito;
	}

	public String toString() {
		return endereco.toString() + " " + conceito;
	}
}
